#!/bin/bash
# awk -f etc/get_values_sim_out.awk -v check_value=2470 -v label=Qheat -v input_no=1 sim_out0_total.dat
#                                                                                        
BEGIN {
# search 2 patterns in sim_out_total to extract cumulative value
# input_no & check_value is given from command line argument
  a=0;
  FirstFoundFlag=0;
  SecondFoundFlag=0;
  check="\ \033[32m\ OK ... done \ \033[37m\ "
#  check="\[\033[32m\]done \[\033[37m\]"
#White       1;37
#Green       0;32
#Red         0;31
# label
# input_no
# check_value
# 
  pattern1=sprintf("##### input:  %d",input_no);
  pattern2="integral:";

}
{ # MAIN check paramter of INFO unit
 for (i=1;i<=1;i++) { if ($0~pattern1)  FirstFoundFlag=i; }
 if ( ($0~pattern2) && (FirstFoundFlag>0) ) {
   value=$2;
   FirstFoundFlag=0;
 }
}
END {
ratio=(check_value-value)/check_value;
if ( ( ratio>0.001) || (ratio<-0.001) ) check="\ \033[31m\ error:0.1[%] ... failed \ \033[37m\ " # "\[\033[32m\]failed"
for (i=1;i<=1;i++) printf("%8s: %s  check: %s  %s\n",label,value,check_value,check);
#printf("\n");
}
