#!/usr/bin/wish
#set unitline 0
set first_time 1
set line 0
set aktiv_input Parameter
set wd /tmp
set lpwd [exec pwd]
set tableout "table.tex"
set export "/tmp/"
set figout "/tmp/figout.fig"
    set filetypes(2) {
	{"Eps-files"		{.eps}	}
	{"All files"		*}
	}
###########PROC LOAD_TYPE#####################################
proc Load_type {begin end} {
   global Unit Type Info
   global figline
set ParList ""
set OutList ""
set InpList ""
set DerList ""
set Unit ""
set Type ""

for {set i $begin} {$i<=$end} {incr i} {
set Zeile $figline($i) 

   if [regexp PAR [lindex $Zeile 13]] {
      lappend ParList $Zeile
   } elseif [regexp OUT [lindex $Zeile 13]] {
      lappend OutList $Zeile
   } elseif [regexp INP [lindex $Zeile 13]] {
      lappend InpList $Zeile
   } elseif [regexp DERIV [lindex $Zeile 13]] {
      lappend DerList $Zeile
   } elseif [regexp UNIT: $Zeile] {
      set Unit $Zeile
   } elseif [regexp TYPE: $Zeile] {
      set Type $Zeile
   } elseif [regexp INFO: $Zeile] {
      set Info $Zeile
   }
}

# Listen sortieren
foreach val {Par Out Inp Der} {
   global [set val]Name [set val]Val [set val]Unit [set val]Comm
   global [set val]ValEin [set val]UnitEin [set val]CommEin
array unset [set val]Val
array unset [set val]ValEin
set [set val]List [lsort -index 13 -dictionary [set [set val]List]] 
#puts [set [set val]List]]
# Arrays fllen
set i 1
foreach Eintrag [set [set val]List] {
    set [set val]Name($i) [lindex $Eintrag 13]
   if {$val != "Out"} {
    if { [regexp {^[\[]} [lindex $Eintrag 14]] &&\
        ![regexp {^[\[]} [lindex $Eintrag 15]] } {
     set [set val]Val($i) ""
     set shift 1
    } else {
    
     set [set val]Val($i) [lindex $Eintrag 14]
     set shift 0
    }
   set [set val]Unit($i) [lindex $Eintrag [expr 15 -$shift]]
   set Comm ""
   for {set j [expr 16 -$shift]} {$j < [expr [llength $Eintrag]-[expr 1+$shift]]} {incr j} {
      set Comm [concat $Comm "[lindex $Eintrag $j] "]
   }
   set [set val]Comm($i) $Comm
  } else {
  #output entrys
      if {![regexp {[\[]}  [lrange  $Eintrag 14 end ]] } {
#puts $Eintrag
        #no unit found put all into comment
        set [set val]Val($i) ""
        set [set val]Unit($i) ""
        set Comm ""
       for {set j 14} {$j < [expr [llength $Eintrag]-1]} {incr j} {
        set Comm [concat $Comm "[lindex $Eintrag $j] "]
       }
       set [set val]Comm($i) $Comm


#        set [set val]Comm($i) [lrange  $Eintrag 14\
#            [expr [llength $Eintrag ] -2] ] 
      } elseif {[regexp {^[\[]} [lindex  $Eintrag 14]] } {
       #unit found but in the value field
        set [set val]Val($i) ".[string tolower $val$i]"
        set [set val]Unit($i) [lindex $Eintrag  14 ]
        set Comm ""
       for {set j 15} {$j < [expr [llength $Eintrag]-1]} {incr j} {
        set Comm [concat $Comm "[lindex $Eintrag $j] "]
       }
       set [set val]Comm($i) $Comm
#        set [set val]Comm($i) [lrange  $Eintrag 15\
#            [expr [llength $Eintrag ] -2] ]
       } else {
       #label exists
        set [set val]Val($i) [lindex $Eintrag 14]
        set [set val]Unit($i) [lindex $Eintrag [expr 15 -$shift]]
        set Comm ""
       for {set j 16} {$j < [expr [llength $Eintrag]-1]} {incr j} {
        set Comm [concat $Comm "[lindex $Eintrag $j] "]
       }
       set [set val]Comm($i) $Comm
#        set [set val]Comm($i) [lrange  $Eintrag 16\
#            [expr [llength $Eintrag ] -2] ] 
       }
  }
   incr i
}
# Listen lschen
unset [set val]List
# Eingabevariablen
array set [set val]ValEin [array get [set val]Val]
array set [set val]UnitEin [array get [set val]Unit]
array set [set val]CommEin [array get [set val]Comm]
#puts "array [set val]ValEin: [array get [set val]ValEin]"
#set [set val]UnitEin(0) ""
#set [set val]CommEin(0) ""
}
}

###########PROC LOAD_TYPE ENDE#####################################
########PROC EXPORT TO EPS###############

proc Export_to_eps {} {
global export wd filetypes Info aktiv_input aktiv
global unit_nr first_time tableout line
set aktiv [string range $aktiv_input 0 2]
set entr [string tolower $aktiv]
   global [set aktiv]Name [set aktiv]Val [set aktiv]Unit [set aktiv]Comm
   global [set aktiv]ValEin [set aktiv]UnitEin [set aktiv]CommEin [set aktiv]Export
set entr [string tolower $aktiv]
set file $export/tmp_$unit_nr.eps
  if {$file != ""} {
#export routine
#make header
      if {!$first_time} {
      set allout [open "$tableout" a]
      set alltxt [open "$wd/tmp.txt" a]
      }
      set texout [open "$wd/tmp.tex" w]
      puts $texout "\\documentclass\[german,a4,7pt\]\{report\}"
      puts $texout "\\setlength\{\\evensidemargin\}\{-0.1cm\}"
      puts $texout "\\setlength\{\\oddsidemargin\}\{-1cm\}"
      puts $texout "\\setlength\{\\textwidth\}\{15cm\}"
      puts $texout "\\setlength\{\\textheight\}\{24.5cm\}"
      puts $texout "\\setlength\{\\voffset\}\{-3cm\}"
      puts $texout "\\usepackage\[german\]\{babel\}"    
      puts $texout "%\\usepackage\{helvetic\}"     
      puts $texout "\\usepackage\[latin1\]\{inputenc\}"
      puts $texout "\\begin\{document\}"
      puts $texout "\\pagestyle\{empty\}"
      puts $texout "\\newcommand\{\} \{$^3$\}"
      puts $texout "\\newcommand\{\} \{$^2$\}"
      puts $texout "\\begin\{small\}" 
      puts $texout "\\begin\{tabular\}\{\|r\|l\|r\|r\|\}  \\hline" 
      puts $texout "\&\{\\bf $aktiv_input  fr [split [lindex $Info 14] _] \} \& \{\\bf  Wert\} \& \{\\bf Einheit\} \\\\ \\hline" 
      incr line
      if {!$first_time} {
    #  puts $allout "\\begin\{tabular\}\{\|r\|l\|r\|r\|\}  \\hline" 
      puts $allout "\&\{\\bf $aktiv_input  fr [split [lindex $Info 14] _] \} \& \{\\bf  Wert\} \& \{\\bf Einheit\} \\\\ \\hline" 
      puts $alltxt "------------------------------------------------------------------------------"
      puts -nonewline $alltxt "\# $aktiv_input  fr [split [lindex $Info 14] _]"  
      	 for {set x [string length "\# $aktiv_input  fr [split [lindex $Info 14] _]"] }\
	  {$x<= 56} {incr x} {
      puts -nonewline $alltxt " " }
      puts $alltxt "|  Wert   | Einheit |"
      puts $alltxt "------------------------------------------------------------------------------"
       }
      
      for {set i 1} {$i<=[array size [set aktiv]Val]} {incr i} {
	set comm ""
     if {!$first_time} {
 	 set part "$i 1 \{[set [set aktiv]CommEin($i)]\} 50 \{[set [set aktiv]ValEin($i)]\} 7 \{[set [set aktiv]UnitEin($i)]\} 7"
	 for {set x 0} {$x< 8} {set x [expr $x+2]} {
	 puts -nonewline $alltxt "| [string range [lindex $part $x] 0 [lindex $part [expr $x+1]]]" 
	 for {set h [string length [lindex $part $x]]} {$h<=[lindex $part [expr $x+1]]} {incr h} {
	 puts -nonewline $alltxt " " }
	 }
	 puts $alltxt "|"
	 }
	#Parse comment for LaTex toxic contents (&;_...)
	regsub -all "&" [set [set aktiv]CommEin($i)] "\\\\\\\\&" liste;#first decontaminate the &
	foreach separator {{=} {:} {,} {;} {\-} {\+} {\*} {\(} {\)}} {
	regsub -all "$separator" $liste " $separator" liste
	}
	regsub -all "<" $liste " \$<\$ " liste
	regsub -all ">" $liste " \$>\$ " liste
	#search for subscripts
	foreach element $liste {
	 #next disarm the _
	for {set under 0} {[regsub  "_" $element "UNDER\{" element]} {incr under} {
	 }
	for {set upper 0} {[regsub  "\\^" $element "UPPER\{" element]} {incr upper} {
	}

	 for {set j 1} {$j<=$under} {incr j} {
	  set element "$element \}"
	 }
	 for {set j 1} {$j<=$upper} {incr j} {
	  set element "$element \}"
	 }
	 if {$under!=0} {
	  regsub -all "UNDER" $element "_" element
	  set element "\$ $element \$"
	 }
	 if {$upper!=0} {
	  regsub -all "UPPER" $element "^" element
	  set element "\$ $element \$"
	 }
	 if {$upper!=0 && $under!=0} {
	  regsub -all "UPPER" $element "^" element
	  regsub -all "UNDER" $element "_" element
	  set element "\$ $element \$"
	 }
	 set comm "$comm $element" 
        }
	foreach greek {alpha beta gamma delta epsilon zeta eta theta iota kappa\
	 		   lambda mu nu xi pi rho sigma tau upsilon phi chi psi omega\
			   Gamma Delta Theta Lambda Xi Pi Sigma Upsilon Phi Psi Omega } {
	  if {[lsearch -exact $comm $greek] >= 0} {
	   set  liste [lreplace $comm [lsearch -exact $comm $greek] \
	   [lsearch -exact  $comm $greek] "\$\\$greek\$" ] } 
	  if {[lsearch -glob $comm "[set greek]_*" ] >= 0} {
	   regsub -all " [set greek]_" $comm " \\[set greek]_" comm }
	}
  	#Parse unit for LaTex       
	 regsub -all "m2" [set [set aktiv]UnitEin($i)] "m\$^2\$" unit
         if {[regexp {[\^]} [set [set aktiv]UnitEin($i)] ] } {
	 set unit "\$[set [set aktiv]UnitEin($i)] ]\$"
	 puts $unit}
         regsub -all "C" $unit "\$^\\circ\$C" unit
	 regsub -all "m2" $unit "m\$^2\$" unit
	 regsub -all "K2" $unit "K\$^2\$" unit
  	#Parse value for LaTex       
         if [regsub -all "e" [set [set aktiv]ValEin($i)] "\$\\cdot 10^\{" value] {
	 set value "$value\}\$" 
	 } else {
	 set value [set [set aktiv]ValEin($i)]
	 }
	 
      puts $texout "$i \& $comm \& $value \& $unit \\\\ \\hline" 
      incr line
      if {!$first_time} {
      if {$line>=55} {
      puts $allout "\\end\{tabular\}"
      puts $allout "\\newpage"
      puts $allout "\\begin\{tabular\}\{\|r\|l\|r\|r\|\}  \\hline" 
      puts $allout "\&\{\\bf $aktiv_input  fr [split [lindex $Info 14] _] (forts.) \} \& \{\\bf  Wert\} \& \{\\bf Einheit\} \\\\ \\hline" 
      set line 0
      }
      puts $allout "$i \& $comm \& $value \& $unit \\\\ \\hline" 
      }
      }
     
     flush $texout
     if {!$first_time} {
   #  puts $allout "\\end\{tabular\}" 
     close $allout
     close $alltxt
     } else {
     exec cp $wd/tmp.tex $tableout
     set first_time 0
     }
     puts $texout "\\end\{tabular\}" 
     puts $texout "\\end\{small\}" 
     puts $texout "\\end\{document\}"
     close $texout

    catch { exec latex -interaction=nonstopmode $wd/tmp.tex}
     exec dvips  -q -E $wd/tmp.dvi -o$file
     exec rm $wd/tmp.aux $wd/tmp.dvi $wd/tmp.log $wd/tmp.tex
  }

#end of Filselection or cancel

}
########PROC EXPORT TO EPS ENDE###############
####PROCEDURE GET_COMPOUND_BORDERS###########################
proc Get_compound_borders {unitnr compound_line maxlines} {
global figline

set i $compound_line
set depth 0
while {[lindex $figline($i) 0] != 6 || $depth>=0} {
  set i [expr $i -1]
#puts $depth
  if {[lindex $figline($i) 0] == -6} {incr depth}
  if {[lindex $figline($i) 0] == 6} {set depth [expr $depth-1]}


  if {$i<9} {puts "Unit $unitnr ist not part of a compound, exit"; exit }
}
set upper_border $i
set i $compound_line
while {[lindex $figline($i) 0] != -6} {
  incr i
#  if {[lindex $figline($i) 0] == 6} {incr depth}
#  if {[lindex $figline($i) 0] == -6} {set depth [expr $depth-1]}
    if {$i>=$maxlines} {puts "Unit $unitnr ist not part of a compound, exit"; exit }
}
set lower_border $i
#change colors etc.
for {set i $upper_border} {$i<=$lower_border} {incr i} {
  if {[regexp {[125]} [lindex $figline($i) 0]] && ![regexp {[\t]} $figline($i)] } {
regsub "\\\\001" $figline($i) "ENDOFTXT" figline($i)
set figline($i) [lreplace $figline($i) 4 4 "6"]
regsub \{  $figline($i) "" figline($i)
regsub \}  $figline($i) "" figline($i)
regsub "ENDOFTXT" $figline($i) "\\\\001" figline($i)
  }
  if {[lindex $figline($i) 0]==4 && ![regexp {[\t]} $figline($i)] } {
regsub "\\\\001" $figline($i) "ENDOFTXT" figline($i)
set figline($i) [lreplace $figline($i) 2 2 "6"]
regsub \{  $figline($i) "" figline($i)
regsub \}  $figline($i) "" figline($i)
regsub "ENDOFTXT" $figline($i) "\\\\001" figline($i)
  }

}
return "$upper_border $lower_border" 
}
##################################################################################################################

set figfile [lindex $argv 0] 
set epsout [lindex $argv 1]
exec rm -f $wd/tmp.txt
if {$argc < 1} {
puts "usage $argv0 <figfile> \[<outfile.eps>\]"
exit}
if {$argc == 1} {
set epsout [tk_getSaveFile  -filetypes $filetypes(2) \
	    -initialdir ./\
	    -initialfile [file tail [file rootname [lindex $argv 0]]].eps -defaultextension .eps]
  if {$epsout == ""} { exit}
destroy .
} 
set fp_in [open $figfile r]
#read figfile
set index 0
while {![eof $fp_in]} {
gets $fp_in Zeile
if {$Zeile != ""} {
set figline($index) $Zeile
incr index
}
set max_figlines [expr $index -1]
}
close $fp_in

cd $wd
for {set index 0} {$index<=$max_figlines} {incr index} {
set Line $figline($index) 
if [regexp UNIT: [lindex $Line 13]] {
set unitline $index
set unit_nr [lindex $Line 14]
set tmp [Get_compound_borders $unit_nr $unitline $max_figlines] 
set begin_line [lindex $tmp 0]
set ending_line [lindex $tmp 1]
set x1 [lindex  $figline($begin_line) 1]
set y1 [lindex  $figline($begin_line) 2]
set x2 [lindex  $figline($begin_line) 3]
set y2 [lindex  $figline($begin_line) 4]
set aspect2 [expr [expr $x2 -$x1]/ [expr $y2-$y1].0]
#puts "aspect ratio2: $aspect2"
#puts "found Unitnr $unit_nr at line $unitline lineborders: $begin_line, $ending_line "
Load_type $begin_line $ending_line
#puts "Par1 of [lindex $Info 14]: $ParVal(1) $ParUnit(1)"
Export_to_eps
set index $unitline
set bounding_box [lrange  [exec grep BoundingBox: [set export]tmp_$unit_nr.eps] 1 4]
set aspect [expr [expr [lindex $bounding_box 1]- [lindex $bounding_box 3]]\
/ [expr [lindex $bounding_box 0]- [lindex $bounding_box 2].0]]
#puts "aspect ratio: $aspect"
#puts "boundingBox: $bounding_box"
if {[expr $aspect2/$aspect]>=10} {
set figline($unitline) "$figline($unitline)\n\#changed by make_info.tcl\n2 5 0 1 0 -1 0 0 -1 0.000 0 0 -1 0 0 5\
\n\t 0 [set export]tmp_$unit_nr.eps\n\t $x1 $y1 $x1 $y2 $x2 $y2 $x2 $y1 $x1 $y1"
} else {
set y2 [format %.0f [expr $y1 +[expr [expr $x2-$x1]*$aspect]]]
set figline($unitline) "$figline($unitline)\n\#changed by make_info.tcl\n2 5 0 1 0 -1 0 0 -1 0.000 0 0 -1 0 0 5\
\n\t 0 [set export]tmp_$unit_nr.eps\n\t $x1 $y1 $x1 $y2 $x2 $y2 $x2 $y1 $x1 $y1"
}
} elseif {$index==6} {
set figline(6) "Single"
}
}
set fp_out [open $figout w]
for {set index 0} {$index<=$max_figlines} {incr index} {
puts $fp_out $figline($index)
}
close $fp_out
exec fig2dev -L eps $figout $epsout
set allout [open $tableout a]
puts $allout "\\end\{tabular\}"
puts $allout "\\end\{small\}"
puts $allout "\\end\{document\}"
close $allout
cd $wd
exec cp tmp.txt [file rootname $epsout].txt
eval exec latex $tableout > latex.out
set epstable [file rootname $epsout]_table.ps
exec dvips -q [file rootname $tableout].dvi -o $epstable
eval exec rm [glob [set export]tmp*.eps]
cd $lpwd
exit
