#!wish -f
# etc/tcl_menu.tcl              
# 010517 new PATH variable
#
set FILENAME $argv
set PATH [ exec pwd ]
# env ( HOME ) ; env ( ColSim ) ;
set ed_pxfig {xterm -bg grey -fg black -geometry 95x70+50+10 -e vim -c /PAR ../.xfig &}
set ed_dek   {xterm -bg grey -fg black -geometry 95x70+50+10 -e vim ./sim.dek &}
exec  >@stdout sed -e s/TYPE/$FILENAME/ \
       <./etc/fig2dekORIGIN | sed -e s/TYPE/$FILENAME/ \
       >./etc/fig2dek 
label .filename -text " filename "
label .file  -text $FILENAME  
label .label -text "ColSim "
button .fig2dek -command "exec <@stdin >@stdout ./etc/fig2dek " \
         -text "fig2dek" -background white 
button .sim -command "exec <@stdin >@stdout ./sim & " \
           -text "sim" -background white 
  button .xterm -command "exec <@stdin >@stdout ./etc/info_edit.ssc  " \
           -text "info_edit" -background white 
  button .exit -command "puts Good-bye; exit"\
           -text "exit" -background blue 
  button .terminator -command "exec <@stdin >@stdout ./etc/Terminator.ssc "\
           -text "terminate" -background red
  button .sort -command "exec <@stdin >@stdout ./etc/xfig.ssc "\
          -text "sort .xfig" -background green
  button .xfg -command "exec <@stdin >@stdout xfig_colsim -bg grey -zoom 0.4 \
          -but_per_row 3 -library_dir $PATH/cnv/lib -dontshowballoons \
           ./projects/$FILENAME/$FILENAME.fig & "\
           -text "xfig" -background white 
  button .mkeps -command "exec <@stdin >@stdout etc/make_info.tcl \
           ./projects/$FILENAME/$FILENAME.fig  "\
           -text "make_info" -background yellow 
  button .ed_pxfig -command "exec <@stdin >@stdout $ed_pxfig "\
                 -text "vim .xfig" -background  white
  button .ed_dek -command "exec <@stdin >@stdout $ed_dek "\
               -text "vim sim.dek" -background  white
  button .make -command "exec <@stdin >@stdout ./etc/SrcMake" \
             -text "make" -background  white
  button .sleep -command "exec <@stdin >@stdout echo n >./no "\
              -text "sleep" -background white
  button .wake_up -command "exec <@stdin >@stdout echo y >./no "\
                -text "wake up" -background white
  button .convert -command "exec <@stdin >@stdout echo x >./no "\
                -text "gnu to .xfig" -background yellow

  pack  .label .file .fig2dek .sim .sleep .wake_up .terminator \
      .xterm .sort .xfg .mkeps .ed_dek .ed_pxfig .make .convert .exit -fill x
