# time columns with printer in ColSim 
set timefmt "%y%m%d%H%M%S"
set xdata time
set format x "%H:%M"
#set autoscale
#set xrange ["981115000000" : "981115070000"]
set title 'load_profile "load.dat"'
set xlabel 'time [h]'
set ylabel 'Power [kW]'
set y2label 'Energy [kWh],Massflow [kg/10h] '
set grid
set xtics 1   #  grid
set y2tics 1   # 1h grid
set ytics 0.1
set tics out
set key below
y1_max=2
y2_max=y1_max*10
set xrange [0:24]
set yrange [0:y1_max]
set y2range [0:y2_max]
#set y2tics

plot [0:24] 'load_dec.dat' us 1:($2) axes x1y2 ti 'massflow mp [kg/h]' wi steps \
 ,'' us 1:3 ti 'P_WW:kW' wi steps,'' us 1:4 axes x1y2 ti 'Q_WW:kWh' wi steps, \
'' us ($1-1):($5*10) axes x1y2 ti 'Q_WW_hour*10_predict' wi steps

