#include "global.h" 
#include <stdio.h>
#include <stdlib.h>

/*-----------------------------------Ausgabe-Input-connections*/
int Ausgabe_Input(int **in_u,int **in_nr,int un_max,int *type,char **type_def_str)
{
  int k1,k2,i;
  printf("\n--input[1..un_max][1..8/INPUT_MAX] -------------------\n");
  for (k1=1;k1<=un_max;k1++)
   {
     for (i=0;i<=12;i++) printf("%1c",type_def_str[ type[k1] ][i]);
     printf("  unit:%2i  ",k1);  /* str[type[k1]] */
     for (k2=1;k2<=8;k2++)   /* opt. bis INPUT_MAX */
      {
        if ( (in_u[k1][k2]!=0)||(in_nr[k1][k2]!=0) )
          {
            printf(" %2i,%2i    ",
            in_u[k1][k2],
            in_nr[k1][k2]);
          }
        else  printf("  ....    ");
      };
     printf("\n");
   };
  return 1;
}


/*-----------------------------------Ausgabe-Out-Pr---*/
int Ausgabe_Out_pr(double **out_n,double **out_o,int un_max,
                   int *type,char **type_def_str, int difference)
{
 int k1,k2,i;
 printf("\n--out[1..un_max][1..8]-------------------------------------\n");
 for (k1=1;k1<=un_max;k1++)
   {
     if (!difference)
     {
       for (i=0;i<=12;i++) printf("%1c",type_def_str[ type[k1] ][i]);
       printf("  unit:%2i  ",k1);  /* str[type[k1]] */
       for (k2=1;k2<=8;k2++)   /*bis 8 oder alle OUT_MAX */
         {
           if (out_n[k1][k2]!=0)
             {
               if (k2>=8) printf("%+3.1e  ",out_n[k1][k2]/3.6e+6);
               else       printf("%+3.1e  ",out_n[k1][k2]);
             }
           else printf("........  ");
         };
       printf("\n");
     }
     else
     {
       for (i=0;i<=12;i++) printf("%1c",type_def_str[ type[k1] ][i]);
       printf("  unit:%2i  ",k1);  /* str[type[k1]] */
       for (k2=1;k2<=8;k2++)   /*bis 8 oder alle OUT_MAX */
         {
           if ( (out_n[k1][k2]-out_o[k1][k2]) !=0)
             {
               if (k2>=8) printf("%+3.1e kWh ",out_n[k1][k2]/3.6e+6);
               else       printf("%+3.1e  ",out_n[k1][k2]);
             }
           else printf("........  ");
         };
       printf("\n");
     }

   };
return 1;
}


/*-----------------------------------Ausgabe-Parameter*/
int Ausgabe_Parameter(double **par,int un_max,int *type,
                      char **type_def_str)
{
  int k1,k2,i;
  printf("\n--parameter[1..un_max][1..8/PAR_MAX]-------------------- \n");
  for (k1=1;k1<=un_max;k1++)
   {
     for (i=0;i<=12;i++) printf("%1c",type_def_str[ type[k1] ][i]);
     printf("  unit:%2i  ",k1);  /* str[type[k1]] */
     for (k2=1;k2<=(8);k2++)  /*oder alle PAR_MAX */
      {
        if (par[k1][k2]!=0)
          {
            printf("%+3.1e  ",
            par[k1][k2]);

          }
        else printf("........  ");
      };
     printf("\n");
   };
  return 1;
}

/*-----------------------------------Print Input-Constants---------------*/
int print_inp_const(double **out_n,double **out_o,int un_max,
                   int *type,char **type_def_str)
{
 int k1,k2,i;
 printf("\n--Input-Constants: out[1..un_max][21..28]-------------------\n");
 for (k1=1;k1<=un_max;k1++)
   {
     for (i=0;i<=12;i++) printf("%1c",type_def_str[ type[k1] ][i]);
     printf("  unit:%2i  ",k1);  /* str[type[k1]] */
     for (k2=31;k2<=38;k2++)   /*bis 28 oder alle 20+INPUT_MAX */
       {
         if (out_n[k1][k2]!=0)
           {
             printf("%+3.1e  ",
             out_n[k1][k2]);
           }
         else printf("........  ");
       };
     printf("\n");
   };
return 1;
}

