/* malloc calls of 1,2,3 dimensional arrays,
   with default setting */

#include <stdio.h>
#include <stdlib.h>

/*
000728 malloc_2int: x+1 pointers !
*/

int a=0; /* analyse prints with 1 */

/*---------------------------------------------1D-----*/
/*test*/
int* malloc_1int(int x)
{
int *ret;
int i;

ret=(int*) malloc(sizeof(int)*(x+1));
if (ret==NULL) { printf("malloc_1int error \n");exit (-1);}
for  (i=0;i<=(x-1);i++) ret[i]=0;

return (ret);
}
float* malloc_1float(int x)
{
float *ret;
int i;

ret=(float*) malloc(sizeof(float)*(x+1));
if (ret==NULL) { printf("malloc_1int error \n");exit (-1);}
for  (i=0;i<=(x-1);i++) ret[i]=0;

return (ret);
}

/*---------------------------------------------2D-----*/
int** malloc_2int(int x,int y)
{
int **ret;
int i,i1;

ret=(int**) malloc(sizeof(int*)*(x+1));
for (i=0;i<=x;i++)
 ret[i]=(int*) malloc(sizeof(int)*(y));
if (ret==NULL) { printf("malloc_2int error \n");exit (-1);} 
/*----------defaults*/
for  (i=0;i<=(x-1);i++)
 for (i1=0;i1<=(y-1);i1++)
   { ret[i][i1]=0; if (a) printf("%d ",ret[i][i1]); }
return (ret);
}

/*---------------------------------------------3D-----*/
int*** malloc_3int(int x,int y,int z)
{
 int ***ret;
 int i,i1,i2;
 ret=(int***) malloc(sizeof(int**)*(x+1)); /* strange linux gcc */
 for (i=0;i<=x;i++)
  {
  ret[i]=(int**) malloc(sizeof(int*)*(y+1));
   for (i1=0;i1<=y;i1++)
   {
   ret[i][i1]=(int*) malloc(sizeof(int)*(z+1));
   }
  }
if (ret==NULL) { printf("malloc_3int error \n");exit (-1);}
/*----------defaults*/
for  (i=0;i<=(x-1);i++)
 for (i1=0;i1<=(y-1);i1++)
  for (i2=0;i2<=(z-1);i2++)
  ret[i][i1][i2]=0;

return (ret);
}



/*---------------------------------------------3D-----*/
double*** malloc_3double(int x,int y,int z)
{
 double ***ret;
 int i,i1,i2;
 ret=(double***) malloc(sizeof(double**)*(x+1)); /* strange linux gcc */
 for (i=0;i<=x;i++)
  {
  ret[i]=(double**) malloc(sizeof(double*)*(y+1));
   for (i1=0;i1<=y;i1++)
   {
   ret[i][i1]=(double*) malloc(sizeof(double)*(z+1));
   }
  }
if (ret==NULL) { printf("malloc_3double error \n");exit (-1);}
/*----------defaults*/
for  (i=0;i<=(x-1);i++)
 for (i1=0;i1<=(y-1);i1++)
  for (i2=0;i2<=(z-1);i2++)
  ret[i][i1][i2]=0;

return (ret);
}

/*---------------------------------------------2D-----*/
double** malloc_2double(int x,int y)
{
double **ret;
int i,i1;

ret=(double**) malloc(sizeof(double*)*(x+1));
for (i=0;i<=x;i++)
 ret[i]=(double*) malloc(sizeof(double)*(y+1));
if (ret==NULL) { printf("malloc_2double error \n");exit (-1);} 
/*----------defaults*/
for  (i=0;i<=x;i++)
 for (i1=0;i1<=y;i1++)
   { ret[i][i1]=0; if (a) printf("ret[%d][%d]:%.1f \n",i,i1,ret[i][i1]); }
return (ret);
}


float** malloc_2float(int x,int y)
{
float **ret;
int i,i1;

ret=(float**) malloc(sizeof(float*)*(x+1));
for (i=0;i<=x;i++)
 ret[i]=(float*) malloc(sizeof(float)*(y+1));
if (ret==NULL) { printf("malloc_2float error \n");exit (-1);}
/*----------defaults*/
for  (i=0;i<=x;i++)
 for (i1=0;i1<=y;i1++)
   { ret[i][i1]=0; if (a) printf("ret[%d][%d]:%.1f \n",i,i1,ret[i][i1]); }
return (ret);
}
/*---------------------------------------------1D-----*/
double *malloc_1double(int x)
{
double *ret;
int i;

ret=(double*) malloc(sizeof(double)*(x+1));
for  (i=0;i<=x;i++) ret[i]=0;
if (ret==NULL) { printf("malloc_1double error \n");exit (-1);}

return (ret);
}

/*---------------------------------------------2D-----*/
char** malloc_2char(int x,int y)
{
char **ret;
int i,i1;

ret=(char**) malloc(sizeof(char*)*(x+1));
for (i=0;i<=x;i++)
 ret[i]=(char*) malloc(sizeof(char)*(y+1));
if (ret==NULL) { printf("malloc_2char error \n");exit (-1);} 
/*----------defaults*/
for  (i=0;i<=x;i++)
 for (i1=0;i1<=y;i1++)
   { ret[i][i1]=' '; if (a) printf("%c ",ret[i][i1]); }
return (ret);
}
/*---------------------------------------------3D-----*/
char*** malloc_3char(int x,int y,int z)
{
 char ***ret;
 int i,i1,i2;
 ret=(char***) malloc(sizeof(char**)*(x+1)); /* strange linux gcc */
   if (ret==NULL) { printf("malloc_3char error:x%d:y%d:z%d\n",x,y,z); }
 for (i=0;i<=x;i++)
  {
  ret[i]=(char**) malloc(sizeof(char*)*(y+1));
   if (ret==NULL) { printf("malloc_3char error:x%d:y%d:z%d\n",x,y,z); }
   for (i1=0;i1<=y;i1++)
   {
   ret[i][i1]=(char*) malloc(sizeof(char)*(z+1));
   if (ret==NULL) { printf("malloc_3char error:x%d:y%d:z%d\n",x,y,z); }
   }
  }
if (ret==NULL) { printf("malloc_3char error \n");exit (-1);}
/*----------defaults */
for  (i=1;i<=(x-1);i++)
 for (i1=1;i1<=(y-1);i1++)
  for (i2=1;i2<=(z-1);i2++)
  ret[i][i1][i2]='\0';

return (ret);
}




