#include <time.h>  
#include <stdio.h>    
#include <stdlib.h>
#include <string.h> 
#include <math.h>    
#include "global.h"

/*
001201 read_box check with next or next-next line compoung-end
010713 unit_max added to interpreter() , exit on missing unit_label
*/

/*----------------------------------interpreter-------------------------*/
int interpreter(int *type,double **par,int **in_u,int **in_nr,
                double **out_n,double **deriv_o
                ,char ***line_word_array,int no_of_lines
                ,int ***input_box,int ***output_box
                ,double **par_xfig,char ***par_comment,
                double **inp_init_xfig,char ***inp_unit_xfig,
                      char ***inp_comment,
                double **deriv_xfig,char ***deriv_comment,
                double **out_xfig,char ***out_unit_xfig,
                       char ***out_comment,
                int *type_xfig,int *unit_xfig,
                char **info_line,
                int **input_unit_xfig,int **input_out_nr_xfig,
                int input_max,int letter_max_line,
                int **compound_coordinates, int **connection,
                int unit_max,struct substitute_struct *subs
                   /* char *CharField_substitute */ )

/* returns no of units in 'sim.fig' */
/* changes unit_no in read_infos()  */
{

#define MAX_COMPOUNDS 3000
int a=0; /*-----------------ANALYSE-PRINTS with a=1!!!!!*/
int unit_read_flag=0;
int current_unit=1;
int unit_read_check=0; /* valid info block found , inc current unit */
int block_no=0;  /* blocks in 'sim.fig' for unit_search */
int i_line=0;
int block_lines   [MAX_COMPOUNDS];
int block_deepness[MAX_COMPOUNDS];
int block_select  [MAX_COMPOUNDS]; /* 0,1,2 search complete couples */
int block_index=0;
int blockcounter=0; 
int erase_counter=0;
int erase_deepness[MAX_COMPOUNDS];
int erase_line    [MAX_COMPOUNDS];
int i1,i,i_pass;
/*int compound_coordinates[UNIT_MAX][5]; */

if (a)
printf("\n-starting with current_unit:%d\n",current_unit);

/* search blocks (compounds in sim.fig (-6 to 6) and eleminate
   blocks greater than 2 infos should be in deepn2*/
/*   index  deepness  blockcounter block_select[blockcounter]

6    1      1         1            1
6    2      2         2            1
6    3      3         3            1
-6   4      3         3            2 complete3       
6    5      3         4            1
-6   6      3         4            2 complete4
-6   7      2         2            2 complete2
-6   8      1         1            2 complete1

*/
block_deepness[0]=0;
block_select  [0]=0;
for (i_line=1;i_line<=no_of_lines;i_line++)
  {
  /* fst word=='6'? ==> new block registrated */
  if (   (strstr(line_word_array[i_line][0],"6") != NULL)
      && (strlen(line_word_array[i_line][0])<=1)
     )
   {
   block_index++;
   if (block_index>=MAX_COMPOUNDS) {
     printf("interpreter.c:block_index>=MAX_COMPOUNDS:%d\n",block_index);
     exit(-1); 
     }
   blockcounter++; /* new block start */
   block_lines   [block_index ]=i_line;
   block_select  [blockcounter]=1; /* block registration */
   /* check deepness, search complete blockselects */
   block_deepness[block_index]  =block_deepness[block_index-1];
   if (block_select[blockcounter-1]!=2)  /* than search current block */
    block_deepness[block_index]=block_deepness[block_index-1]+1;
    
   if (a) printf("line:%d index:%3d deepness:%1d bl.count:%3d bl.sel:%1d [\n"
     ,i_line,block_index,block_deepness[block_index],
    blockcounter, block_select  [blockcounter]);
   }
  /* fst word=='-6'? ==> block end */
  if (    (strstr(line_word_array[i_line][0],"-6") != NULL)
       && (strlen(line_word_array[i_line][0])<=2)
     )
   {
   block_index++;
   block_deepness[block_index]=block_deepness[block_index-1];
   if (block_select[blockcounter]==2)  /* than search current block */
    {
    block_deepness[block_index]-=1;
    i=blockcounter;
    do i--; while ( (block_select[i]>1) && (i>1) );
    /* blockcounter=i; / * take last block with select==1 */
    }
   else i=blockcounter;
   block_select  [i]=2; /* block close */
   block_lines   [block_index ]=i_line;
   if (a) printf("line:%d index:%3d deepness:%1d bl.count:%3d bl.sel:%1d .]\n"
     ,i_line,block_index,block_deepness[block_index],
     i , block_select  [blockcounter]);
   }
  } /* end eleminate deep blocks */

i1=0;
block_lines[block_index+1]=block_lines[block_index];
block_deepness[block_index+1]=0;
erase_counter=0;
for (i=1;i<=block_index;i++) 
 {
/*
 printf("line_word_array[block_lines[i  ]][1]:%s\n",
      line_word_array[block_lines[i+1  ]][1] );
*/
  /* delete '-6' line on registrated multiple compound */
  if (   (erase_counter>0) 
      && (block_deepness[i]==erase_deepness[erase_counter])
     )
     {
     if (1) printf("                     erase line comp.end:%d deepn:%d\n"
      ,block_lines[i],block_deepness[i]);
     erase_counter--;
     line_word_array[ block_lines[i] ][0][0]='\0'; /* erase this line */
     }
 /* compare '6 x1 y1 x2 y2' with following compund open 
    to check multiple compunds of xfig (paste-bug) */
 if (  ( block_deepness[i+1]>block_deepness[i] ) /* next compound */
     &&( strstr(line_word_array[block_lines[i  ]][1]
              , line_word_array[block_lines[i+1]][1] ) != NULL)
     &&( strstr(line_word_array[block_lines[i  ]][2]
              , line_word_array[block_lines[i+1]][2] ) != NULL)
     &&( strstr(line_word_array[block_lines[i  ]][3]
              , line_word_array[block_lines[i+1]][3] ) != NULL)
     &&( strstr(line_word_array[block_lines[i  ]][4]
              , line_word_array[block_lines[i+1]][4] ) != NULL)
    ) 
    {
    erase_counter++;
    erase_deepness[erase_counter]=block_deepness[i];
    erase_line    [erase_counter]=block_lines[i];
    if (1) printf("line1:%d&%d identic comp.-coordinate:%s deepn:%d\n",
        block_lines[i],block_lines[i+1]
       ,line_word_array[ block_lines[i] ][1]
       ,erase_deepness[erase_counter] );
     line_word_array[ block_lines[i] ][0][0]='\0'; /* erase this line */
    
    }
 
 /*
 if (block_deepness[i]==1) 
  { i1++; if (1) printf("line:%d compound:%d found \n",block_lines[i],i1); }
 */
 }


unit_read_flag=0;
current_unit=1;
unit_read_check=0; /* valid info block found , inc current unit */

for (i_pass=1;i_pass<=2;i_pass++) /* 2nd pass :create connections */
{
 


block_no=0;
for (i_line=1;i_line<=no_of_lines;i_line++)
{

  /* fst word=='6'? ==> new block registrated */
  if (   (strstr(line_word_array[i_line][0],"6") != NULL)
      && (strlen(line_word_array[i_line][0])<=1)
     )
   {
   block_no++;
   if (a) printf("line:%d new block: %d \n",i_line,block_no);
   if (block_no==1) {
     int k=0;
      if (0) printf("---comp-coordinates--\n");
     for (k=1;k<=4;k++) {
      compound_coordinates[current_unit][k]
                       =strtod(line_word_array[i_line][k],NULL);
      if (0) printf("compound[%d][%d]:%d\n"
                    ,current_unit,k,compound_coordinates[current_unit][k]); 
     }
     if (a) printf("current_unit:%d \n",current_unit);
     compound_coordinates[current_unit+1][1]=END;
   }
   continue; /* i_line loop */
   }

  /* fst word=='-6'? ==> block end */
  if (    (strstr(line_word_array[i_line][0],"-6") != NULL)
       && (strlen(line_word_array[i_line][0])<=2)
     )
   {
   if (a) printf("line:%d block end: %d \n",i_line,block_no);
   block_no--;
   if ( (block_no==0) && (unit_read_flag) )
    {
      unit_read_flag=0;
      if (unit_read_check) {
        current_unit++;
        if (current_unit>unit_max+1) {
         printf("interpreter: current_unit:%d unit_max:%d \n",
                current_unit,unit_max);
         printf("missing unit_label in some compounds ? , exiting\n");
         exit (-1);
        }
      }
      unit_read_check=0; /* try to read infos */
      if (a) printf("line:%d block completet block_no:%d ---current_unit:%d\n"
               ,i_line,block_no,current_unit);
    }
   continue; /* i_line loop */
   }

  if (block_no>=2) unit_read_flag=1;

  if (0) printf("i_line:%d unit_read_flag:%d block_no:%d\n"
   ,i_line,unit_read_flag,block_no);

  /*-------------------read connection boxes ---------------------*/
    /* search polygon (2 3),text-line and end-compound sign */
    /* line with polygon "2 3", next line textentry "4 ",
       next or next-next line compoung-end "-6"
    */
  if (     (strstr(line_word_array[i_line]  [0],"2") != NULL)
        && (strlen(line_word_array[i_line]  [0])<=1)
	&& (strstr(line_word_array[i_line]  [1],"3") != NULL)
	&& (strlen(line_word_array[i_line]  [1])<=1)
        && (strstr(line_word_array[i_line+2][0],"4") != NULL)
        && (strlen(line_word_array[i_line+2][0])<=1)
        && (  ( /* check this or next line for compound end */
                  (strstr(line_word_array[i_line+3][0],"-6") != NULL)
               && (strlen(line_word_array[i_line+3][0])<=2)
              )
           ||
              (
                  (strstr(line_word_array[i_line+4][0],"-6") != NULL)
               && (strlen(line_word_array[i_line+4][0])<=2)
              )  
           )
        && (unit_read_flag)
        && (i_pass==1)
     )
     {
     if (a) printf("unit:%d connection box detected in line:%d \n"
                   ,current_unit,i_line);
     if (read_box(line_word_array,i_line,unit_read_flag,
                  input_box,output_box,current_unit,input_max,
                  subs /* CharField_substitute*/ )
         ==-1
        ) {printf("no box detected\n");}
     i_line+=2;
     continue;
     }

  /*----------------read dek infos-----------------------------*/
  if (      (strstr(line_word_array[i_line][0],"4") != NULL)
         && (strlen(line_word_array[i_line][0])<=1)
         && (unit_read_flag)
         && (i_pass==1)
     )
     {
     if (a) printf("read dek infos \n");
     if (read_infos(line_word_array,i_line,current_unit,
                    par_xfig,par_comment,
                    inp_init_xfig,inp_unit_xfig,inp_comment,
                    deriv_xfig,deriv_comment,
                    out_xfig,out_unit_xfig,out_comment,
                    type_xfig,unit_xfig,info_line,letter_max_line
                   )
         ==-1
        )
        {
        if (a) printf("text without info_keyword i_line:%d\n",i_line);
        continue;
        }
      else unit_read_check=1; 
      }
  /*---------read connections--------------------------------*/
  if (     (strstr(line_word_array[i_line]  [0],"2") != NULL)
        && (strlen(line_word_array[i_line]  [0])<=1)
	&& (strstr(line_word_array[i_line]  [1],"1") != NULL)
	&& (strlen(line_word_array[i_line]  [1])<=1)
        /* && (!unit_read_flag) */
        && (block_no==0) /* connections only outside of compounds */
        && (i_pass==2)
     )
     {
     if (a) printf("reading connections \n");
     if (read_connections(line_word_array,i_line,current_unit,
                          input_box,output_box,(current_unit-1),
                          input_unit_xfig,input_out_nr_xfig,
                          input_max,connection,subs)
         ==-1
        )
        {
        printf("no connection found for a line-symbol (return "
	       "read_connections()=-1\n");
        continue;
        }
     }

  } /*next i_line */
} /* 2nd pass i_pass */
return (current_unit-1);
} /*end_of interpreter */

/*--------------------------------------------------------------------*/


