#include <stdio.h>    
#include <stdlib.h>
#include <string.h> 
#include <math.h>    
#include "global.h"

/*
001109 out_comment in column 15 line_word_array[i_line][15]
*/

/*------------------------------read_infos---------------------------*/
int read_infos(char ***line_word_array,int i_line,int current_unit,
               double **par_xfig,char ***par_comment,
               double **inp_init_xfig,char ***inp_unit_xfig,
                      char ***inp_comment,
               double **deriv_xfig,char ***deriv_comment,
               double **out_xfig,char ***out_unit_xfig,
                      char ***out_comment,
               int *type_xfig,int *unit_xfig,
               char **info_line, int letter_max_line )
{
int a=0; /*--------------------ANALYSE a=1-------------------------*/
int check=-1;
int read_no_flag=0;
int no_offset=0; /* offset for number position */
int no;         /* number of the parameter.. */
int i_letter=0,i_word=0,i=0;
char rest1[100],*rest;

int page_background=1; /* set letters in the background */

rest=rest1;

/* search keywords with differnt numbers------*/
/* later try to define keyword_string[6] := i=0..5 line_word_array[i_line][13] */
/* problem: keyword OUT in a user defined string in the xfig-object */

if (strstr(line_word_array[i_line][13],"OUT") != NULL)
  { read_no_flag=1; no_offset=0; }

if (strstr(line_word_array[i_line][13],"INP") != NULL)
  { read_no_flag=2; no_offset=0; }

if (strstr(line_word_array[i_line][13],"PAR") != NULL)
  { read_no_flag=3; no_offset=0; }

if (strstr(line_word_array[i_line][13],"DERIV") != NULL)
  { read_no_flag=4; no_offset=2; }

if ( (read_no_flag>0) && (page_background) )
  {
    sprintf(line_word_array[i_line][2],"7" ); /* color white */
    if (strlen(line_word_array[i_line][3])>=2) /*no space left in array */
       sprintf(line_word_array[i_line][3],"99"); /* depht */
    else printf("write infos depht 50 error : line: %d word3:%s !\n",
                i_line,line_word_array[i_line][3]);
  }
if ( (read_no_flag>0) && (!page_background) ) /* reset letters */
  {
    sprintf(line_word_array[i_line][2],"0" ); /* color black */
    if (strlen(line_word_array[i_line][3])>=2)
       sprintf(line_word_array[i_line][3],"12"); /* depht */
    else printf("write infos depht 12 error !\n");
  }

if (read_no_flag > 0) /*------------------ read no -----------*/
  {
   check=1;
   switch ((char) line_word_array[i_line][13][3+no_offset]) /*no_read*/
     {
     case '0': no=0; break;
     case '1': no=1; break;
     case '2': no=2; break;
     case '3': no=3; break;
     case '4': no=4; break;
     case '5': no=5; break;
     case '6': no=6; break;
     case '7': no=7; break;
     case '8': no=8; break;
     case '9': no=9; break;
     default:  printf("error in keyword:%d in unit:%d  \n",read_no_flag,
                        current_unit); exit(-1);
     }
   switch ((char) line_word_array[i_line][13][4+no_offset]) /*2nd no*/
     {
     case '0': no=no*10  ; break;
     case '1': no=no*10+1; break;
     case '2': no=no*10+2; break;
     case '3': no=no*10+3; break;
     case '4': no=no*10+4; break;
     case '5': no=no*10+5; break;
     case '6': no=no*10+6; break;
     case '7': no=no*10+7; break;
     case '8': no=no*10+8; break;
     case '9': no=no*10+9; break;
     default:  break; /* out_no < 10 ! */
     }


   /*---------------------------read values---------------------------*/

   if (read_no_flag==1) /* --------------------------take "OUT"-arrays */
     {
     if (a) printf("line:%d word:%d string:%s\n"
           ,i_line,14,line_word_array[i_line][14]);
     if (a) printf("line:%d word:%d string:%s\n"
           ,i_line,15,line_word_array[i_line][15]);
     if (no>OUT_MAX) { printf("read_infos: out_box:%d > OUT_MAX:%d\n"
         ,no,OUT_MAX);exit (-1); }
     out_xfig     [current_unit][no]
       = strtod(line_word_array[i_line][14],&rest);

     out_unit_xfig[current_unit][no]
       =        line_word_array[i_line][15]; /* pointer !! */

     /*
     i_letter=0;i_word=0;
     while   (line_word_array[i_line][16+i_word][0] != '\0')
       {
       i=0;
       while (line_word_array[i_line][16+i_word][i] != '\0')
         {
         out_comment  [current_unit][no][i_letter]
          =   line_word_array[i_line][16+i_word][i];
         i++;
         i_letter++;
	 if ( (i_letter>80) || (i_word>30) ) { printf("no comment in OUT line:%d\n"
	                                       ,i_line); exit (-1); }
         }
       out_comment  [current_unit][no][i_letter]=' ';
       i_letter++;i_word++;
       }
     out_comment  [current_unit][no][i_letter]='\0';
     */

     out_comment  [current_unit][no]
       =        line_word_array[i_line][15]; /* pointer !! */

     if (a)  printf("line:%d OUT:%d found with value:%.4f string:%s\n",i_line,no,
             out_xfig     [current_unit][no],out_comment  [current_unit][no]);
     if (  (strstr("\\001",out_comment  [current_unit][no])!=NULL)
        && (strlen(out_comment  [current_unit][no])>4 ) )
      {
      printf("line:%d OUT:%d found with value:%.4f out_comment:%s:%d\n",i_line,no,
             out_xfig     [current_unit][no],out_comment  [current_unit][no],
       strlen(out_comment  [current_unit][no]) );
      exit (-1);
      }
     }

   if (read_no_flag==2) /* take --------------------------"INP"-arrays */
     {
     inp_init_xfig[current_unit][no]
       = strtod(line_word_array[i_line][14],&rest);

     if (a)
     printf("line:%d word:%d INP:%d found with value:%.4f unit:%d\n"
            ,i_line,14,no, inp_init_xfig[current_unit][no],current_unit);

     inp_unit_xfig[current_unit][no]
       =        line_word_array[i_line][15]; /* pointer !! */

            /* inp_comment  [current_unit][no]
              =        line_word_array[i_line][16];  pointer !! */

     /* copy all words of comment , but not \001 */
     i_letter=0;i_word=0;
 
     while(  (line_word_array[i_line][16+i_word+1][0] != '\0')
           &&(line_word_array[i_line][16+i_word+0][0] != '\\')  
           &&(line_word_array[i_line][16+i_word+0]    != NULL ) )
       {
       if (a) printf("line:%d word:%d %s \n",i_line,16+i_word+1,line_word_array[i_line][16+i_word+1]);
       i=0;
       while (  (line_word_array[i_line][16+i_word][i] != '\0')
              &&(line_word_array[i_line][16+i_word][i] != ' ') )
         {
         if (a) printf("i:%d :%c:\n",i,line_word_array[i_line][16+i_word][i]);
         inp_comment  [current_unit][no][i_letter]          /* copy */
          =   line_word_array[i_line][16+i_word][i];
         if (a) printf("2i:%d :%c:\n",i,line_word_array[i_line][16+i_word][i]);
         i++;
         i_letter++;
	 if ( (i_letter>letter_max_line) || (i_word>30) ) { 
           printf("no comment in INP line:%d\n" ,i_line); exit (-1); }
         if (a) printf("3i:%d :%c:\n",i,line_word_array[i_line][16+i_word][i]);
         inp_comment  [current_unit][no][i_letter]=' ';
         inp_comment  [current_unit][no][i_letter+1]='\0';
         }

       if (a) printf("4i:%d :%c:\n",i,line_word_array[i_line][16+i_word][i]);
       i_letter++;i_word++;i=0;
       if (a) printf("try line_word_array[%d][%d][%d]:\n",i_line,16+i_word+1,0);
       if (line_word_array[i_line][16+i_word+1]==NULL) { exit (-1); }
       if (a) printf("1try line_word_array[%d][%d][%d]:%c\n",i_line,16+i_word+1,0,line_word_array[i_line][16+i_word+1][0]);

       }
    }

   if (read_no_flag==3) /* -------------------------- take "PAR"-arrays */
     {
     par_xfig[current_unit][no]
       = strtod(line_word_array[i_line][14],&rest);

     if (a)
     printf("PAR:%d found with value:%.4f current_unit:%d no:%d\n",no,
            par_xfig[current_unit][no],current_unit,no);

     /* copy all words of comment , but not \001 */
     i_letter=0;i_word=0;
     while   (line_word_array[i_line][15+i_word+1][0] != '\0')
       {
       i=0;
       while (line_word_array[i_line][15+i_word][i] != '\0')
         {
#if 0
printf("i_line:%d i_letter:%d i_word:%d i_:%d string:%s par%d,%d,%d\n"
 ,i_line,i_letter,i_word,i,&line_word_array[i_line][15+i_word][i]
 ,current_unit,no,i_letter);
printf("par_comment:%c\n",
par_comment  [0][0][0]);
         if (a) printf("%c",line_word_array[i_line][15+i_word][i]);
fflush(stdout);
#endif
         par_comment  [current_unit][no][i_letter]          /* copy */
          =   line_word_array[i_line][15+i_word][i];
         i++;
         i_letter++;
	 if ( (i_letter>letter_max_line) || (i_word>30) ) { 
            printf("no comment in PAR line:%d\n" ,i_line); exit (-1); }
         }
       par_comment  [current_unit][no][i_letter]=' ';
       i_letter++;i_word++;
       }
     par_comment  [current_unit][no][i_letter]='\0';
          /*
          par_comment[current_unit][no]
          =        line_word_array[i_line][15];  pointer !! */
     }


   if (read_no_flag==4) /* ------------------------- take "DERIV"-arrays */
     {
     deriv_xfig[current_unit][no]
       = strtod(line_word_array[i_line][14],&rest);

     if (a)
     printf("DERIV:%d found with value:%.4f\n",no,
            deriv_xfig[current_unit][no]);

     deriv_comment[current_unit][no]
       =        line_word_array[i_line][15]; /* pointer !! */

     }

  }


 /*------------------if TYPE --------------------------------------------*/
if (strstr(line_word_array[i_line][13],"TYPE:") != NULL)
  {
  check=1;
  type_xfig[current_unit]
   = (int) strtod(line_word_array[i_line][14],&rest);

  if (a)
  printf("TYPE found with value:%d\n",
          type_xfig[current_unit]);
  }

/*---------------------if "UNIT" ------------------------------------------*/
if (strstr(line_word_array[i_line][13],"UNIT:") != NULL)
 {
 check=1;
 /*----------------------order units--------------------*/
 if (   (int) strtod(line_word_array[i_line][14],&rest) != current_unit)
    {
    printf("unit_no changed: %d --> %d \n"
           ,(int) strtod(line_word_array[i_line][14],&rest)
           ,current_unit
          );
    if ( inttostr(current_unit, line_word_array[i_line][14]) ==-1)
       printf("error convert int-->string \n");

    if (0) printf("integer-value:%d converted from string:%s:\n"
           ,(int) strtod(line_word_array[i_line][14],&rest)
           ,line_word_array[i_line][14]
          );
    }
 unit_xfig[current_unit]=current_unit;

 if (a) printf("UNIT found with value:%d\n", unit_xfig[current_unit]);
 }


if (strstr(line_word_array[i_line][13],"INFO:") != NULL)
 {
 check=1;
 info_line[current_unit] = line_word_array[i_line][14];
 }

return (check);
}
/*--------------------------------------------------------------*/

