#
# awk -f boxes.awk -v x=1 -v dx=1 -v dy1=2 -v dy2=3 -v dy3=4 -v dy4=5 -v offs=500 -v f=-1 boxes.dat >boxes.gnu.dat
#
# x:x-coordinate dx:box-width dy1=y-lenght of value1  offs:offset delta-y f:scaling 1:pos -1:neg
#
# gnuplot
# !awk -f boxes.awk ...
# plot "boxes.gnu.dat" us 1:2:3:4 wi boxxy,"" us 5:6:7:8 wi boxxy,"" us 9:10:11:12 wi boxxy
#
BEGIN {
 a=0;
 if (dy1!=0) printf("#x y1 dx dy1 ");
 if (dy2!=0) printf(" x y2 dx dy2 ");
 if (dy3!=0) printf(" x y3 dx dy3 ");
 if (dy4!=0) printf(" x y4 dx dy4 ");
 printf("\n");

 if (f==0) f=1; # user positiv scaling
 }
{
if ((substr($1,1,1)!="#") && ($2!=0) )
 {
 if (dy1!=0) printf("%f %f %f %f ",$(x),offs+0                         +f*0.5*$(dy1),dx*0.5,f*0.5*$(dy1) );
 if (dy2!=0) printf("%f %f %f %f ",$(x),offs+f*$(dy1)                  +f*0.5*$(dy2),dx*0.5,f*0.5*$(dy2) );
 if (dy3!=0) printf("%f %f %f %f ",$(x),offs+f*$(dy1)+f*$(dy2)         +f*0.5*$(dy3),dx*0.5,f*0.5*$(dy3) );
 if (dy4!=0) printf("%f %f %f %f ",$(x),offs+f*$(dy1)+f*$(dy2)+f*$(dy3)+f*0.5*$(dy4),dx*0.5,f*0.5*$(dy4) );

 printf("\n");

 }
}


