#2345678901234567890123456789012345678901234567890123456789012345678901234567890
#--------1---------2---------3---------4---------5---------6---------7---------8
set TYPEDEF "./src/init_type_def_str.c"
set SRCPATH "./src"
set wd [exec pwd]
set aktiv_input ""
set export "$wd/tmp/"
#xfig_bug auf 1 setzen falls objekte beim pasten nicht nochmal eingepackt werden
    set filetypes(1) {
	{"LaTex file"		{.tex}	}
	{"All files"		*}
    }
    set filetypes(2) {
	{"Eps-files"		{.eps}	}
	{"All files"		*}
    }
set xfig_bug 1
######PROC LOAD & SORT VALUES FROM .XFIG######################
proc Load_type {} {
   global Unit Type Info
   global aktiv_input
set ParList ""
set OutList ""
set InpList ""
set DerList ""
set Unit ""
set Type ""

# .xfig einlesen
set DateiEin [open ".xfig" r]

while {![eof $DateiEin]} {
   gets $DateiEin Zeile

   if [regexp PAR [lindex $Zeile 13]] {
      lappend ParList $Zeile
   } elseif [regexp OUT [lindex $Zeile 13]] {
      lappend OutList $Zeile
   } elseif [regexp INP [lindex $Zeile 13]] {
      lappend InpList $Zeile
   } elseif [regexp DERIV [lindex $Zeile 13]] {
      lappend DerList $Zeile
   } elseif [regexp UNIT: $Zeile] {
      set Unit $Zeile
   } elseif [regexp TYPE: $Zeile] {
      set Type $Zeile
   } elseif [regexp INFO: $Zeile] {
      set Info $Zeile
   }
}
puts $ParList
close $DateiEin

# Listen sortieren
foreach val {Par Out Inp Der} {
   global [set val]Name [set val]Val [set val]Unit [set val]Comm
   global [set val]ValEin [set val]UnitEin [set val]CommEin

set [set val]List [lsort -index 13 -dictionary [set [set val]List]] 
puts [set [set val]List]]
# Arrays fllen
set i 1
foreach Eintrag [set [set val]List] {
    set [set val]Name($i) [lindex $Eintrag 13]
   if {$val != "Out"} {
    if { [regexp {^[\[]} [lindex $Eintrag 14]] &&\
        ![regexp {^[\[]} [lindex $Eintrag 15]] } {
     set [set val]Val($i) ""
     set shift 1
    } elseif {[regexp {[0-9.]+} [lindex $Eintrag 14] ] ||\
     [regexp {^[\[]} [lindex $Eintrag 14]]} {
     set [set val]Val($i) [lindex $Eintrag 14]
     set shift 0
    } else {
     set [set val]Val($i) ""
     set shift 2
    }
   set [set val]Unit($i) [lindex $Eintrag [expr 15 -$shift]]
   set Comm ""
   for {set j [expr 16 -$shift]} {$j < [expr [llength $Eintrag]-[expr 1+$shift]]} {incr j} {
      set Comm [concat $Comm "[lindex $Eintrag $j] "]
   }
   set [set val]Comm($i) $Comm
  } else {
  #output entrys
      if {![regexp {[\[]}  [lrange  $Eintrag 14 end ]] } {
#puts $Eintrag
        #no unit found put all into comment
        set [set val]Val($i) ""
        set [set val]Unit($i) ""
        set Comm ""
       for {set j 14} {$j < [expr [llength $Eintrag]-1]} {incr j} {
        set Comm [concat $Comm "[lindex $Eintrag $j] "]
       }
       set [set val]Comm($i) $Comm


#        set [set val]Comm($i) [lrange  $Eintrag 14\
#            [expr [llength $Eintrag ] -2] ] 
      } elseif {[regexp {^[\[]} [lindex  $Eintrag 14]] } {
       #unit found but in the value field
        set [set val]Val($i) ".[string tolower $val$i]"
        set [set val]Unit($i) [lindex $Eintrag  14 ]
        set Comm ""
       for {set j 15} {$j < [expr [llength $Eintrag]-1]} {incr j} {
        set Comm [concat $Comm "[lindex $Eintrag $j] "]
       }
       set [set val]Comm($i) $Comm
#        set [set val]Comm($i) [lrange  $Eintrag 15\
#            [expr [llength $Eintrag ] -2] ]
       } else {
       #label exists
        set [set val]Val($i) [lindex $Eintrag 14]
        set [set val]Unit($i) [lindex $Eintrag [expr 15 -$shift]]
        set Comm ""
       for {set j 16} {$j < [expr [llength $Eintrag]-1]} {incr j} {
        set Comm [concat $Comm "[lindex $Eintrag $j] "]
       }
       set [set val]Comm($i) $Comm
#        set [set val]Comm($i) [lrange  $Eintrag 16\
#            [expr [llength $Eintrag ] -2] ] 
       }
  }
   incr i
}
# Listen lschen
unset [set val]List
# Eingabevariablen
set [set val]ValEin(0) ""
set [set val]UnitEin(0) ""
set [set val]CommEin(0) ""
}
}

# Fenster erzeugen
proc Hauptmenu {} {
wm title . "info edit ColSim T. Knapp & K. Lustig" 
global Unit Type Info
global aktiv_input
#wm resizable . 0 0

menu .menu -tearoff 0
bind . <Control-s> "SaveAndExit"
bind . <Control-q> "destroy ."
set m .menu.file
menu $m -tearoff 0
.menu add cascade -label file -menu $m -underline 0
$m add command -label "Sort & Update type from source" \
   -command {
   exec ./etc/xfig.ssc
    destroy .[string range [string tolower $aktiv_input] 0 2]
    destroy .ueber[string range [string tolower $aktiv_input] 0 2]
   Entry $aktiv_input
   } -underline 12

$m add command -label "Get values from sim.dek" \
   -command {Get_val_from_sim [lindex $Info 14]} -underline 12
$m add command -label "Update all from source" \
   -command {Get_val_from_src [lindex $Type 14]} -underline 4
$m add command -label "Export entry to LaTex table" \
   -command {Export_to_latex} -underline 4
$m add command -label "Export entry to eps" \
   -command {Export_to_eps} -underline 4
$m add command -label "Save and Exit" -command "SaveAndExit" -accelerator Ctrl-s -underline 0
$m add command -label "Exit without Save" -command "destroy ." -accelerator Ctrl-q  -underline 0

set m .menu.fields
menu $m -tearoff 0
.menu add cascade -label entries -menu $m -underline 1
$m add command -label Par -command {Entry Parameter } -underline 0
$m add command -label Input -command {Entry Input} -underline 0
$m add command -label Output -command {Entry  Output} -underline 0
$m add command -label Deriv -command {Entry  Deriv} -underline 0

. configure -menu .menu
set width [lindex [exec head -n 1 .xfig.xbm] 2]
frame .ueberblock 
pack .ueberblock -side top  
frame .ueberblock.text -relief raised
label .ueberblock.bild -bitmap @./.xfig.xbm  -width [expr $width*0.65] -anchor w
pack .ueberblock.text .ueberblock.bild -side left  -expand 1

frame .ueberblock.text.unit -bd 2
pack .ueberblock.text.unit -expand 1 -side top -fill x

label .ueberblock.text.unit.text -text Unit: -width 10  -anchor w
label .ueberblock.text.unit.ein -text [lindex $Unit 14]  -justify right -anchor e
pack .ueberblock.text.unit.text .ueberblock.text.unit.ein -side left

frame .ueberblock.text.type -bd 2
pack .ueberblock.text.type -expand 1 -side top -fill x

label .ueberblock.text.type.text -text Type:  -width 10  -anchor w
label .ueberblock.text.type.ein -text [lindex $Type 14] -justify right -anchor e
pack .ueberblock.text.type.text .ueberblock.text.type.ein -side left

frame .ueberblock.text.info -bd 2
pack .ueberblock.text.info -expand 1 -side top -fill x

label .ueberblock.text.info.text -text Info:   -width 10 -anchor w
label .ueberblock.text.info.ein -text [lindex $Info 14]  -justify right -anchor e
pack .ueberblock.text.info.text .ueberblock.text.info.ein -side left -expand 1 -fill y
}
#--------------------------------------------------------------------------------
# Ereignisse verknpfen
# Default-Werte setzen

# Entry ANFANG
proc Entry {entry} {
   set val [string range $entry 0 2]
   global [set val]Name [set val]Val [set val]Unit [set val]Comm
   global [set val]ValEin [set val]UnitEin [set val]CommEin
   global aktiv_input
   set aktiv_input $entry
   set entr [string tolower [string range $entry 0 2]]
   if [winfo exists .$entr] {
      return
   } elseif [winfo exists .out] {
      destroy .ueberout .out
   } elseif [winfo exists .der] {
      destroy .ueberder .der
   } elseif [winfo exists .par] {
      destroy .ueberpar .par
   } elseif [winfo exists .inp] {
         destroy .ueberinp .inp
   }

   frame .ueber$entr -bd 2
   pack .ueber$entr -side top -fill x
   label .ueber$entr.text -text $aktiv_input  -anchor w
   frame .ueber$entr.sep -relief ridge -bd 2 -height 2
   pack .ueber$entr.text -side top
   pack .ueber$entr.sep -side top -fill x -expand 1
   frame .ueber$entr.head -bd 1 
   pack .ueber$entr.head -side top -expand 1 -fill x

   label .ueber$entr.head.text -width 10
   if {$aktiv_input != "Output"} {
    label .ueber$entr.head.value -text value -width 10 -anchor w
   } else {
    label .ueber$entr.head.value -text label -width 10 -anchor w
   }
   label .ueber$entr.head.sep1 -width 4
   label .ueber$entr.head.unit -text unit -width 8 -anchor w
   label .ueber$entr.head.sep2 -width 3
   label .ueber$entr.head.comment -text comment -width 18  -anchor w

   pack .ueber$entr.head.text .ueber$entr.head.value .ueber$entr.head.sep1 .ueber$entr.head.unit .ueber$entr.head.sep2 \
      .ueber$entr.head.comment -side left

  frame .$entr -bd 2 -class Dialog
   pack .$entr -expand on -side bottom -fill y
  scrollbar .$entr.vscroll -command ".$entr.canvas yview"
    pack .$entr.vscroll -side right -fill y
  canvas .$entr.canvas -height 1\
		-relief flat -borderwidth 0 -yscrollcommand ".$entr.vscroll set" \
		-width 54 
  pack .$entr.canvas -expand 1 -side bottom -fill y


frame .$entr.f 
 pack .$entr.f -side top

    for {set i 1} {$i <= [array size [set val]Val]} {incr i} {
      frame .$entr.f.$i -bd 1
      pack .$entr.f.$i -side top -expand 1 -fill x

      label .$entr.f.$i.text -text "[set [set val]Name($i)]" -width 10 -anchor w
      entry .$entr.f.$i.value -width 10 -relief sunken -bd 2 \
         -textvariable [set val]ValEin($i) -justify right
      label .$entr.f.$i.sep1 -width 3
      entry .$entr.f.$i.unit -width 8 -relief sunken -bd 2 \
         -textvariable [set val]UnitEin($i) -justify right
      label .$entr.f.$i.sep2 -width 3
      entry .$entr.f.$i.comment -width 20 -relief sunken -bd 2 \
         -textvariable [set val]CommEin($i) -justify left
if { $i <  [array size [set val]Val]} {
	bind .$entr.f.$i.value <Return>  "focus .$entr.f.[expr $i+1].value" 		
	bind .$entr.f.$i.value <Down>  "focus .$entr.f.[expr $i+1].value" 		
}	
if {$i >1 } {bind .$entr.f.$i.value <Up>  "focus .$entr.f.[expr $i-1].value"} 			

      pack .$entr.f.$i.text .$entr.f.$i.value .$entr.f.$i.sep1 .$entr.f.$i.unit .$entr.f.$i.sep2 \
         .$entr.f.$i.comment -side left

      .$entr.f.$i.value delete 0 end
      .$entr.f.$i.value insert 0 [set [set val]Val($i)]
      .$entr.f.$i.unit delete 0 end
      .$entr.f.$i.unit insert 0 [set [set val]Unit($i)]
      .$entr.f.$i.comment delete 0 end
      .$entr.f.$i.comment insert 0 [set [set val]Comm($i)]
   }
	update idletasks
.$entr.canvas create window 0 0 -anchor nw -window .$entr.f
	.$entr.canvas configure \
		-width [expr [winfo reqwidth .$entr.f] + 1]\
		-scrollregion "-1 -1 [expr [winfo reqwidth .$entr.f] + 1] \
			 [expr [winfo reqheight .$entr.f]+1]"
	set winy  [winfo reqh .] 
	set scry [expr [winfo screenh .] * 1/2]
	set maxy [expr $scry - [winfo reqh .ueberblock]]
	set canvtotal [winfo reqh .$entr.f]
	if { $winy  < $scry} {
		.$entr.canvas configure -height $canvtotal
	} else {
		.$entr.canvas configure -height  $maxy 
	}
	update idletasks

}
#-------------------------------------------------------------------------------
# entry ENDE



#-------------------------------------------------------------------------------
# Save and Exit ANFANG
proc SaveAndExit {} {
   global ParName ParValEin ParUnitEin ParCommEin
   global ParVal ParUnit ParComm
   global InpName InpValEin InpUnitEin InpCommEin
   global InpVal InpUnit InpComm
   global OutName OutValEin OutUnitEin OutCommEin
   global OutVal OutUnit OutComm
   global DerName DerValEin DerUnitEin DerCommEin
   global DerVal DerUnit DerComm
   global xfig_bug

   if {[array size InpValEin] < 2} {
      array set InpValEin [array get InpVal]
      array set InpUnitEin [array get InpUnit]
      array set InpCommEin [array get InpComm]
   }

   if {[array size OutUnitEin] < 2} {
      array set OutValEin [array get OutVal]
      array set OutUnitEin [array get OutUnit]
      array set OutCommEin [array get OutComm]
   }

   if {[array size DerValEin] < 2} {
      array set DerValEin [array get DerVal]
      array set DerUnitEin [array get DerUnit]
      array set DerCommEin [array get DerComm]
   }

   # .xfig einlesen
   set DateiEin [open ".xfig" r]
#   set DateiAus [open ".xfig" w]
   set DateiAus [open ".xfig.aus" w]

   set ParZ 1
   set OutZ 1
   set InpZ 1
   set DerZ 1
   set lines 1
   while {![eof $DateiEin]} {
      gets $DateiEin Zeile
      if [regexp PAR [lindex $Zeile 13]] {
         set Zeile [lreplace $Zeile 13 end]
         set Zeile [concat $Zeile $ParName($ParZ) $ParValEin($ParZ) \
            $ParUnitEin($ParZ) $ParCommEin($ParZ) {\001}]
         incr ParZ
      } elseif [regexp OUT [lindex $Zeile 13]] {
         set Zeile [lreplace $Zeile 13 end]
         set Zeile [concat $Zeile $OutName($OutZ) $OutValEin($OutZ) $OutUnitEin($OutZ) \
            $OutCommEin($OutZ) {\001}]
         incr OutZ
      } elseif [regexp INP [lindex $Zeile 13]] {
         set Zeile [lreplace $Zeile 13 end]
         set Zeile [concat $Zeile $InpName($InpZ) $InpValEin($InpZ) \
            $InpUnitEin($InpZ) $InpCommEin($InpZ) {\001}]
         incr InpZ
      } elseif [regexp DERIV [lindex $Zeile 13]] {
         set Zeile [lreplace $Zeile 13 end]
         set Zeile [concat $Zeile $DerName($DerZ) $DerValEin($DerZ) \
            $DerUnitEin($DerZ) $DerCommEin($DerZ) {\001}]
         incr DerZ
      }
#xfig bug packt alle Objekte nochmal
	if {$xfig_bug==1} {
		set row($lines) $Zeile
   		incr lines}	

    	if {$xfig_bug==0} {  
   	   puts $DateiAus $Zeile}
   }

   close $DateiEin
   if {$xfig_bug==1} {
   for {set i 1} {$i<[expr $lines - 2]} {incr i} {
      if {$i!=10} {
       puts $DateiAus $row($i)} }
       		    }
   close $DateiAus

   destroy .
}

########PROC GET_VAL_FROM_SIM###############

proc Get_val_from_sim {type_name} {
   global ParVal ParUnit ParComm
   global ParValEin ParUnitEin ParCommEin
   global DerVal DerUnit DerComm
   global DerValEin DerUnitEin DerCommEin
#open sim.dek
puts "Info_edit warning: INPUTS and OUTPUTS are not updated"
   set SimEin [open "sim.dek" r]
gets $SimEin Zeile
    while {![eof $SimEin]} {
if { [lindex $Zeile 0] == "UNIT" && [lindex $Zeile 5] == $type_name } {
set unitnr [lindex $Zeile 1]
# reached right type in sim.dek
  while {[lrange $Zeile 0 1] != "UNIT [expr $unitnr +1]" } {
    gets $SimEin Zeile
    foreach section "Params Derivatives" {
      if {[lindex $Zeile 0] == [string toupper $section]} {
       set nr 1
       set entr  "[string range $section 0 2]" 
       set nr_max [lindex $Zeile 1]

       for {set i 1} {$i<=[expr $nr_max*2]} {incr i} {
         gets $SimEin Zeile
	 if {[lindex $Zeile 0] != "*"} {
         set [set entr]Val($nr) [lindex $Zeile 0]
         set [set entr]ValEin($nr) [lindex $Zeile 0]
	 incr nr
	} else {
	#comment, unit insert
         set [set entr]Unit($nr) [lindex $Zeile 2]
         set [set entr]UnitEin($nr) [lindex $Zeile 2]
         set [set entr]Comm($nr) [lrange $Zeile 3 end ]
         set [set entr]CommEin($nr) [lrange $Zeile 3 end]
	}	
      }
     }
   }
 } 
} else {
}  
 gets $SimEin Zeile
}
close $SimEin
}
########PROC GET_VAL_FROM_SRC###############

proc Get_val_from_src {type_nr} {
set pattern_list "Par Inp Out Deriv"
set BEGIN_FLAG 0
global TYPEDEF SRCPATH
#first get the source file
regsub , [exec grep "TYPE $type_nr " $TYPEDEF] "" grep_str
#make it relative to "SOURCE" (more save)
set src_index [expr [lsearch -exact $grep_str "SOURCE"]+1]
set src_file $SRCPATH/[lindex $grep_str $src_index]
#puts $src_file
#now open the src file
set src_fp [open "$src_file" r]
    gets $src_fp Zeile
    while {[gets $src_fp] !="\{" } { };#ignoring header
    while {[lindex $Zeile 0] !="*/"} {
     gets $src_fp Zeile
    
     foreach section $pattern_list {
   global [string range $section 0 2]Val [string range $section 0 2]Unit [string range $section 0 2]Comm
   global [string range $section 0 2]ValEin [string range $section 0 2]UnitEin [string range $section 0 2]CommEin
       if {[string match "[string toupper $section]*" [lindex $Zeile 0]] } {
	regexp {[0-9]+} [lindex $Zeile 0] nr
        set entr  "[string range $section 0 2]" 
	if {![regexp {[\[]} $Zeile ]} {
        #no unit found put all into comment
	puts "info_edit warning: no unit found at [string toupper $section]$nr\: in $src_file put all information in comment" 
	set shift_flag -1 
	} elseif {[regexp {^[\[]} [lindex $Zeile 1] ]} { 
       #unit found but in the value field
	set shift_flag 1
	} else {
	set shift_flag 0
	}
	if {$shift_flag >=0} {	
        set [set entr]Val($nr) [lindex $Zeile [expr 1 -$shift_flag]]
        set [set entr]ValEin($nr) [lindex $Zeile [expr 1 -$shift_flag]]
	if { [set [set entr]Val($nr)] == "[string toupper $section]$nr\:" } {
        set [set entr]Val($nr) ""
        set [set entr]ValEin($nr) ""
	 }
        set [set entr]Unit($nr) [lindex $Zeile [expr 2 -$shift_flag]]
        set [set entr]UnitEin($nr) [lindex $Zeile [expr 2 -$shift_flag]]
        set [set entr]Comm($nr) "[lrange $Zeile [expr 3 -$shift_flag] end]"
        set [set entr]CommEin($nr) "[lrange $Zeile [expr 3 -$shift_flag] end]"
	} else {
        set [set entr]Val($nr) ""
        set [set entr]ValEin($nr) ""
        set [set entr]Unit($nr) ""
        set [set entr]UnitEin($nr) ""
        set [set entr]Comm($nr) "[lrange $Zeile 1 end]"
        set [set entr]CommEin($nr) "[lrange $Zeile 1 end]"
	}

#unused entries will be destroyed
#	if {[llength $Zeile] <=2} {
#	destroy .[string range [string tolower $entr] 0 2].$nr  }

     }
    }
   }
close $src_fp
}
########PROC EXPORT TO LATEX###############

proc Export_to_latex {} {
global export wd filetypes Info aktiv_input aktiv
set aktiv [string range $aktiv_input 0 2]
set entr [string tolower $aktiv]
   global [set aktiv]Name [set aktiv]Val [set aktiv]Unit [set aktiv]Comm
   global [set aktiv]ValEin [set aktiv]UnitEin [set aktiv]CommEin [set aktiv]Export
for {set i 1} {$i<=[array size [set aktiv]Val]} {incr i} {
set [set aktiv]Export($i) 1
checkbutton .$entr.f.$i.export -variable [set aktiv]Export($i) -justify right 
pack .$entr.f.$i.export -side left 
}
button .ueber$entr.head.export -text Export -command {
set entr [string tolower $aktiv]
set initdir  $export
if {$initdir == "."} {set initdir $wd}
set file [tk_getSaveFile  -filetypes $filetypes(1) \
	    -initialdir $initdir\
	    -initialfile [lindex $Info 14]_$entr.tex -defaultextension .tex]
  if {$file != ""} {
#export routine
#make header
      set texout [open "$file" w]
      puts $texout "\\begin\{tabular\}\{\|l\|r\|r\|\}  \\hline" 
      puts $texout "\{\\bf $aktiv_input  fr [split [lindex $Info 14] _] \} \& \{\\bf  Wert\} \& \{\\bf Einheit\} \\\\ \\hline" 

      for {set i 1} {$i<=[array size [set aktiv]Val]} {incr i} {
       if {[set [set aktiv]Export($i)]} {
	set comm ""
	#Parse comment for LaTex toxic contents (&;_...)
	regsub -all "&" [set [set aktiv]CommEin($i)] "\\\\\\\\&" liste;#first decontaminate the &
	foreach separator {{=} {:} {,} {;} {\-} {\+} {\*} {\(} {\)}} {
	regsub -all "$separator" $liste " $separator" liste
	}
	regsub -all "<" $liste " \$<\$ " liste
	regsub -all ">" $liste " \$>\$ " liste
	foreach element $liste {
	 #next disarm the _
	for {set under 0} {[regsub  "_" $element "UNDER\{" element]} {incr under} {
	 }
	 for {set j 1} {$j<=$under} {incr j} {
	  set element "$element \}"
	 }
	 if {$under!=0} {
	  regsub -all "UNDER" $element "_" element
	  set element "\$ $element \$"
	 }
	 set comm "$comm $element" 
        }
	foreach greek {alpha beta gamma delta epsilon zeta eta theta iota kappa\
	 		   lambda mu nu xi pi rho sigma tau upsilon phi chi psi omega\
			   Gamma Delta Theta Lambda Xi Pi Sigma Upsilon Phi Psi Omega } {
	  if {[lsearch -exact $comm $greek] >= 0} {
	   set  liste [lreplace $comm [lsearch -exact $comm $greek] \
	   [lsearch -exact  $comm $greek] "\$\\$greek\$" ] } 
	  if {[lsearch -glob $comm "[set greek]_*" ] >= 0} {
	   regsub -all " [set greek]_" $comm " \\[set greek]_" comm }
	}
  	#Parse unit for LaTex       
	 regsub -all "m2" [set [set aktiv]UnitEin($i)] "m\$^2\$" unit
         if {[regexp {[\^]} [set [set aktiv]UnitEin($i)] ] } {
	 set unit "\$[set [set aktiv]UnitEin($i)] ]\$"
	 puts $unit}
         regsub -all "C" $unit "\$^\\circ\$C" unit
	 regsub -all "m2" $unit "m\$^2\$" unit
	 regsub -all "K2" $unit "K\$^2\$" unit
  	#Parse value for LaTex       
         if [regsub -all "e" [set [set aktiv]ValEin($i)] "\$\\cdot 10^\{" value] {
	 set value "$value\}\$" 
	 } else {
	 set value [set [set aktiv]ValEin($i)]
	 }
	 
      puts $texout "$comm \& $value \& $unit \\\\ \\hline" 
      };#end of checkbutton
     }
     puts $texout "\\end\{tabular\}" 
     close $texout
  }
#end of Filselection or cancel
  destroy .ueber$entr.head.export
  for {set i 1} {$i<=[array size [set aktiv]Val]} {incr i} {
     destroy  .$entr.f.$i.export
  }
	.$entr.canvas configure \
		-width [expr [winfo reqwidth .$entr.f] - 25]
#update idletasks

}
pack .ueber$entr.head.export -side right -anchor e
	.$entr.canvas configure \
		-width [expr [winfo reqwidth .$entr.f] + 25]
}
########PROC EXPORT TO EPS###############

proc Export_to_eps {} {
global export wd filetypes Info aktiv_input aktiv
set aktiv [string range $aktiv_input 0 2]
set entr [string tolower $aktiv]
   global [set aktiv]Name [set aktiv]Val [set aktiv]Unit [set aktiv]Comm
   global [set aktiv]ValEin [set aktiv]UnitEin [set aktiv]CommEin [set aktiv]Export
for {set i 1} {$i<=[array size [set aktiv]Val]} {incr i} {
set [set aktiv]Export($i) 1
checkbutton .$entr.f.$i.export -variable [set aktiv]Export($i) -justify right 
pack .$entr.f.$i.export -side left 
}
button .ueber$entr.head.export -text Export -command {
set entr [string tolower $aktiv]
set initdir  $export
if {$initdir == "."} {set initdir $wd}
set file [tk_getSaveFile  -filetypes $filetypes(2) \
	    -initialdir $initdir\
	    -initialfile [lindex $Info 14]_$entr.eps -defaultextension .eps]
  if {$file != ""} {
#export routine
#make header
      set texout [open "tmp.tex" w]
      puts $texout "\\documentclass\[german,a4,11pt\]\{report\}"
      puts $texout "\\usepackage\[german\]\{babel\}"    
      puts $texout "\\usepackage\{helvetic\}"     
      puts $texout "\\usepackage\[latin1\]\{inputenc\}"
      puts $texout "\\begin\{document\}"
      puts $texout "\\pagestyle\{empty\}"
      puts $texout "\\begin\{tabular\}\{\|l\|r\|r\|\}  \\hline" 
      puts $texout "\{\\bf $aktiv_input  fr [split [lindex $Info 14] _] \} \& \{\\bf  Wert\} \& \{\\bf Einheit\} \\\\ \\hline" 

      for {set i 1} {$i<=[array size [set aktiv]Val]} {incr i} {
       if {[set [set aktiv]Export($i)]} {
	set comm ""
	#Parse comment for LaTex toxic contents (&;_...)
	regsub -all "&" [set [set aktiv]CommEin($i)] "\\\\\\\\&" liste;#first decontaminate the &
	foreach separator {{=} {:} {,} {;} {\-} {\+} {\*} {\(} {\)}} {
	regsub -all "$separator" $liste " $separator" liste
	}
	regsub -all "<" $liste " \$<\$ " liste
	regsub -all ">" $liste " \$>\$ " liste
	foreach element $liste {
	 #next disarm the _
	for {set under 0} {[regsub  "_" $element "UNDER\{" element]} {incr under} {
	 }
	 for {set j 1} {$j<=$under} {incr j} {
	  set element "$element \}"
	 }
	 if {$under!=0} {
	  regsub -all "UNDER" $element "_" element
	  set element "\$ $element \$"
	 }
	 set comm "$comm $element" 
        }
	foreach greek {alpha beta gamma delta epsilon zeta eta theta iota kappa\
	 		   lambda mu nu xi pi rho sigma tau upsilon phi chi psi omega\
			   Gamma Delta Theta Lambda Xi Pi Sigma Upsilon Phi Psi Omega } {
	  if {[lsearch -exact $comm $greek] >= 0} {
	   set  liste [lreplace $comm [lsearch -exact $comm $greek] \
	   [lsearch -exact  $comm $greek] "\$\\$greek\$" ] } 
	  if {[lsearch -glob $comm "[set greek]_*" ] >= 0} {
	   regsub -all " [set greek]_" $comm " \\[set greek]_" comm }
	}
  	#Parse unit for LaTex       
	 regsub -all "m2" [set [set aktiv]UnitEin($i)] "m\$^2\$" unit
         if {[regexp {[\^]} [set [set aktiv]UnitEin($i)] ] } {
	 set unit "\$[set [set aktiv]UnitEin($i)] ]\$"
	 puts $unit}
         regsub -all "C" $unit "\$^\\circ\$C" unit
	 regsub -all "m2" $unit "m\$^2\$" unit
	 regsub -all "K2" $unit "K\$^2\$" unit
  	#Parse value for LaTex       
         if [regsub -all "e" [set [set aktiv]ValEin($i)] "\$\\cdot 10^\{" value] {
	 set value "$value\}\$" 
	 } else {
	 set value [set [set aktiv]ValEin($i)]
	 }
	 
      puts $texout "$comm \& $value \& $unit \\\\ \\hline" 
      };#end of checkbutton
     }
     puts $texout "\\end\{tabular\}" 
     puts $texout "\\end\{document\}"
     close $texout
     exec latex tmp.tex
     exec dvips -q -E tmp.dvi -o$file
     exec rm tmp.aux tmp.dvi tmp.log tmp.tex
  }

#end of Filselection or cancel
  destroy .ueber$entr.head.export
  for {set i 1} {$i<=[array size [set aktiv]Val]} {incr i} {
     destroy  .$entr.f.$i.export
  }
	.$entr.canvas configure \
		-width [expr [winfo reqwidth .$entr.f] - 25]
#update idletasks

}
pack .ueber$entr.head.export -side right -anchor e
	.$entr.canvas configure \
		-width [expr [winfo reqwidth .$entr.f] + 25]
}
#####PROC CONVERT XBM#########################

proc Convert_xbm {} {
exec fig2dev -L xbm -m 0.5 .xfig .xfig.xbm
}
#-------------------------------------------------------------------------------
# Save and Exit ENDE

#-------------------------------------------------------------------------------
# MsgNochNicht ANFANG
proc MsgNochNicht {w} {
   set button [tk_messageBox -icon info -type ok \
	-title "Noch nicht!!!" -parent $w\
	-message "Funktion noch nicht implementiert!"]
}
#-------------------------------------------------------------------------------
# MsgNochNicht ENDE
Convert_xbm
Load_type
Hauptmenu
Entry Parameter
