######################################################
# change values in     ColSim/cnv/sys/< ___ .fig >   #
# called from          ColSim/<substitut_script>     # 
#                                                    #
######################################################
{
# switch off/on what you will change

  node_number =1
  humidity_pipe =1
  diameter_outside_pipe =1
  diameter_inside_pipe =1
  temp_mass =1        # DERIV1
  temp_pipe =0        # DERIV1   
  lambda_const =1
  cp_const =1
  rho_const =1
  T_oo_x_neg =1
  T_oo_x_pos =1
  T_oo_z_neg =1
  T_oo_z_pos =1
  T_oo_y_neg =1
  T_oo_y_pos =1  
  m_margin=1

# change number of nodes in ewt_solarhaus.fig
  if( $0~/number of node/)
    {  
      if( node_number == 1 )                 # 0:dont change; 1:change
        {  $15 =10
         print $0 
        }
      else  print $0        # if (0) --> print line unchanged 
    }


# change relativ humidity in pipe_air.c
  else if ( $0~/relative humidity in pipe/)
    {
      if ( humidity_pipe == 1 )         # 0:dont change; 1:change
        {  $15 =0.5
           print $0
        }
      else                               # if (0) --> print line unchanged
        {  print $0
        } 
    }


# change diameter pipe_air.c
  else if ( $0~/outside diameter pipe/)   # outside diameter
    {
      if ( diameter_outside_pipe == 1 )  # 0:dont change; 1:change
        {  $15 =0.209
           print $0
        }
      else                               # if (0) --> print line unchanged
        {  print $0
        }
    }

  else if ($0~/inside diameter pipe/)    #inside diameter
    {
      if ( diameter_inside_pipe == 1 )    # 0:dont change; 1:change
        {  $15 =0.20
           print $0
        }
      else                   # if (0) --> print line unchanged
        {  print $0
        }
    }

# change temperature mass_element.c   
  else if ($0~/mass begining temp of node/)
    {
      if ( temp_mass == 1 )  # 0:dont change; 1:change
        {  $15 =-100
           print $0
        }
      else                               # if (0) --> print line unchanged
        {  print $0
        }

    } 


# change temperature pipe_air.c
  else if ($0~/pipe begining temp of node 1/)
    {
      if ( temp_pipe == 1 )  # 0:dont change; 1:change
        {  $15 =11
           print $0
        }
      else                               # if (0) --> print line unchanged
        {  print $0
        }
    }    

# change in mass lambda_ct #
  else if ($0~/lambda_ct' 0:calc with PAR10;/)
    {
      if ( lambda_const =1 )            # 0:dont change; 1:change 
        {  $15 =1.7   #1.915    1.7
           print $0
        }
      else                               # if (0) --> print line unchanged
        {  print $0
        }
    }          

# change in mass cp_ct #
  else if ($0~/cp_ct' 0:calc with PAR10;/)
    {
      if ( cp_const =1 )                 # 0:dont change; 1:change 
        {  $15 =1079  # 899  1079 
           print $0
        }
      else                               # if (0) --> print line unchanged
        {  print $0
        }
    } 
 
# change in mass rho_ct  #       
  else if ($0~/rho_ct' 0:calc with PAR10;/)
    {
      if ( rho_cont =1 )                 # 0:dont change; 1:change 
        {  $15 =2250 #   1550 2250     
           print $0
        }
      else                               # if (0) --> print line unchanged
        {  print $0
        }
    }       

# change surface temp mass (-x)  #
  else if ($0~/-x const. margin temp/)
    {
    if( T_oo_x_neg =1 )             # 0:dont change; 1:change 
      {  $15 =-100
         print $0
      }
    else                               # if (0) --> print line unchanged
      {  print $0
      }
    }                                                                         


# change surface temp mass (+x)  #
  else if ($0~/+x const. margin temp/)
    {
    if( T_oo_x_pos =1 )             # 0:dont change; 1:change
      {  $15 =-100
         print $0
      }
    else                               # if (0) --> print line unchanged
      {  print $0
      }
    }


# change surface temp mass (-z)  #
  else if ($0~/-z const. margin temp/)
    {
    if( T_oo_z_neg =1 )            # 0:dont change; 1:change
      {  $15 =-100
         print $0
      }
    else                               # if (0) --> print line unchanged
      {  print $0
      }
    }


# change surface temp mass (+z)  #
  else if ($0~/+z const. surface temp/)
    {
    if( T_oo_z_pos =1 )             # 0:dont change; 1:change
      {  $15 =-100
         print $0
      }
    else                               # if (0) --> print line unchanged
      {  print $0
      }
    }


# change surface temp mass (-y)  #
  else if ($0~/-y const. margin temp/)
    {
    if( T_oo_y_neg =1 )            # 0:dont change; 1:change
      {  $15 =-100
         print $0
      }
    else                               # if (0) --> print line unchanged
      {  print $0
      }
    }


# change surface temp mass (+y)  #
  else if ($0~/+y const. margin temp/)
    {
    if( T_oo_y_pos =1 )             # 0:dont change; 1:change
      {  $15 =14
         print $0
      }
    else                               # if (0) --> print line unchanged
      {  print $0
      }
    }

# change mode_margin  #
  #else if ($0~/0:ct Temp 1:funct. 2:funct. if Par15 to Par20 =-100/)  */
  else if ($0~/period funct. for margin temp/)
    {
    if( m_margin =1 )             # 0:dont change; 1:change
      {  $15 =1
         print $0
      }
    else                               # if (0) --> print line unchanged
      {  print $0
      }
    }            


# print unchanged line
  else            
    {  print $0
    }


}





