#!/bin/bash
# awk -f etc/summenhaeufigkeit.awk  dat/system8_3/jahresdauerlinie8_3pu.dat
# p [0:100] 'dat/system8_3/jahresdauerlinie8_3pu.dat' us (100*$1/8760):2 w i
#
BEGIN {
  a=0;
h10=0;
h20=0;
h30=0;
h40=0;
h50=0;
h60=0;
h70=0;
h80=0;
h90=0;
h100=0;
}
{ # MAIN check paramter of INFO unit
if (!match($1,"#") ) {
 hour_of_year=$1
 T_pump=$2
 relative_hour=100.0*hour_of_year/8760.0
 if (relative_hour>100.0) relative_hour=100.0;
 if ( (T_pump>10) && (h10==0) )    h10=relative_hour;
 if ( (T_pump>20) && (h20==0) )    h20=relative_hour;
 if ( (T_pump>30) && (h30==0) )    h30=relative_hour;
 if ( (T_pump>40) && (h40==0) )    h40=relative_hour;
 if ( (T_pump>50) && (h50==0) )    h50=relative_hour;
 if ( (T_pump>60) && (h60==0) )    h60=relative_hour;
 if ( (T_pump>70) && (h70==0) )    h70=relative_hour;
 if ( (T_pump>80) && (h80==0) )    h80=relative_hour;
 if ( (T_pump>90) && (h90==0) )    h90=relative_hour;
 if ( (T_pump>100) && (h100==0) ) h100=relative_hour;
} # valid line
} # MAIN
END {
printf("h10:%.1f \n",h10);
printf("h20:%.1f \n",h20);
printf("h30:%.1f \n",h30);
printf("h40:%.1f \n",h40);
printf("h50:%.1f \n",h50);
printf("h60:%.1f \n",h60);
printf("h70:%.1f \n",h70);
printf("h80:%.1f \n",h80);
printf("h90:%.1f \n",h90);
printf("h100:%.1f \n",h100);

}

