
/* work around macros */
#define ssGetOutputPortRealSignal(x,y) (*S).out[0]                /* outputs */
#define ssGetInputPortRealSignalPtrs(x,y)  (*S).inp               /* inputs */
#define ssGetSFcnParam(x,y) (*S).par[0][y]                        /* pars */ 

/* simulink macros */
/* Defines for easy access to parameters */
#define VDOT_NOM(S)    (ssGetSFcnParam(S,0)) /* par0 */
#define DP_NOM(S)      (ssGetSFcnParam(S,1)) /* par1 */



#define VDOT_NOM(S)    (ssGetSFcnParam(S,0))
#define DP_NOM(S)      (ssGetSFcnParam(S,1))
#define MAN_SPEC(S)    (ssGetSFcnParam(S,2))
#define DELTA_RFMIN(S) (ssGetSFcnParam(S,3))
#define DEHU_UPH(S)    (ssGetSFcnParam(S,4))
#define EFF_DE_RWZ(S)  (ssGetSFcnParam(S,5))
#define EFF_DE_RFZ(S)  (ssGetSFcnParam(S,6))


double *mxGetPr(double dummy) { return &dummy; } /* dummy function for parameters */

typedef double** InputRealPtrsType;

typedef struct
{
  double **par;
  double **inp;
  double **out;
} SimStruct;
typedef int int_T;
typedef double real_T;

static void mdlOutputs(SimStruct *S, int_T tid);


